unit Graph;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, CustomAlphaPanel, StdCtrls, ComCtrls,MathExpression;

type
  TForm4 = class(TForm)
    AlphaPanel1: TAlphaPanel;
    Memo1: TMemo;
    Image1: TImage;
    Edit1: TEdit;
    Button1: TButton;
    Button3: TButton;
    ListBox1: TListBox;
    ProgressBar1: TProgressBar;
    SaveDialog1: TSaveDialog;
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
     procedure BuildGraph(Value: String);
  public
    { Public declarations }
  end;
procedure ShowGraphBox;
var
  Form4: TForm4;

const
  radian = 180 / pi;


implementation
uses shellapi;

{$R *.dfm}

procedure TForm4.BuildGraph(Value: String);
var
  i, y: Integer;
  x: Extended;
  ErrorCode, ClientH, ClientW: Word;
  Time1: LongWord;
  Res: String;
begin
  ProgressBar1.Position := 0;

  Time1 := GetTickCount;

  Memo1.Lines.Clear;
  if Pos('y=', Value) > 0 then
    Value := Copy(Value, 3, 255);

  Image1.Canvas.Lock;
  Image1.Canvas.FillRect(Rect(0, 0, Image1.Width, Image1.Height));
  Image1.Canvas.MoveTo(Image1.Width div 2, 0);
  Image1.Canvas.LineTo(Image1.Width div 2, Image1.Height);
  Image1.Canvas.MoveTo(0, Image1.Height div 2);
  Image1.Canvas.LineTo(Image1.Width, Image1.Height div 2);
  ClientW := Image1.Width div 2; ClientH := Image1.Height div 2;
  {x+}
  x := 0;
  for i := 0 to 1500 do
  begin
    ErrorCode := CalcGraphExpression(Value, x * radian, Res);
    if ErrorCode <> C_NOERROR then
    begin
      Memo1.Lines.Add(' : ' + CalcErrorToStr(ErrorCode));
      Break;
    end;
    y := - Trunc(StrToFloat(Res) * 10) + ClientH;
    if (y >= 0) or (y <= Image1.Height) then
      Image1.Canvas.Pixels[Trunc(x * 1000) + ClientW, y] := RGB($FF, 0, 0);
    x := x + 0.0001;

    if i mod 30 = 0 then {1500 / 50%}
      ProgressBar1.Position := ProgressBar1.Position + 1;
  end;

  {x-}
  x := 0;
  for i := 0 to 1500 do
  begin
    ErrorCode := CalcGraphExpression(Value, x * radian, Res);
    if ErrorCode <> C_NOERROR then
    begin
      Memo1.Lines.Add(' : ' + CalcErrorToStr(ErrorCode));
      Break;
    end;
    y := - Trunc(StrToFloat(Res) * 10) + ClientH;
    if (y >= 0) or (y <= Image1.Height) then
      Image1.Canvas.Pixels[Trunc(x * 1000) + ClientW, y] := RGB($FF, 0, 0);

    x := x - 0.0001;

    if i mod 30 = 0 then {1500 / 50%}
      ProgressBar1.Position := ProgressBar1.Position + 1;
  end;
  Image1.Canvas.Unlock;

  Memo1.Lines.Add(' : ' + IntToStr(GetTickCount - Time1) + 'ms')
end;

procedure TForm4.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex <> - 1 then
  begin
    Edit1.Text := ListBox1.Items[ListBox1.ItemIndex];
    BuildGraph(ListBox1.Items[ListBox1.ItemIndex]);
  end;
end;


procedure TForm4.Button1Click(Sender: TObject);
begin
  BuildGraph(Edit1.Text);
end;



procedure ShowGraphBox;
begin
  with TForm4.Create(Application) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TForm4.Button3Click(Sender: TObject);
begin
    with TSaveDialog.Create(Self) do
  begin
    Filter := ' (*.bmp)|*.bmp';
    DefaultExt := 'bmp';
    if Execute then
      Image1.Picture.SaveToFile(FileName);
    Free;
  end;
end;

end.
